/***************************************************************/
/***                                                         ***/
/*** Modifica del contenuto dei campi della card selezionata ***/
/***                                                         ***/
/***************************************************************/

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#ifndef SUB_CALLING
#  include <gtk/gtk.h>
#  include <stdio.h>
#  include <string.h>
#  include <malloc.h>
#  include <unistd.h>
#  include <sys/types.h>
#  include <sys/stat.h>
#  include <fcntl.h>
#  include "callbacks.h"
#  include "interface.h"
#  include "support.h"
#  include "pfunc.h"
#  include "sfunc.h"
#  include "mfunc.h"
#  include "telefono.h"
#  include "iofile.h"
#endif

#include "rafobj.h"

void
on_modifica_activate (GtkMenuItem * menuitem, gpointer user_data)
{
	RAF_DEBUG_INIT{"on_modifica_activate"};
  int i;
  GtkWidget *text;
	struct card *rc;

	RAF_DEBUG("started");
  if (Status[S_RUBRICA])
  {
    if (Modifica == NULL)
			Modifica = create_modifica ();
    text = lookup_widget (GTK_WIDGET (Modifica), "card_preview");
    gtk_text_set_word_wrap (GTK_TEXT (text), 1);

    Status[S_SELCAMPO] = -1;  /* Nessun campo  selezionato */
    Status[S_CMPMOD] = 0;     /* Nessun campo ancora modificato */
    Status[S_CRDMOD]++;       /* Un'altra card modificata */
    RAF_DEBUG ("Status[S_CAMPI]=%d\n", Status[S_CAMPI]);
		
		rc = raf_object_get_slt(RAF_OBJ_SLT);
		/* 2001-07-05: creo una copia della card per 
		   avere modo di ritornare sulle modifiche */
		CardCopia = duplica_card(rc);
    for (i = 0; i < Status[S_CAMPI]; i++) {
	  	RAF_DEBUG("ContenutoCampi[%d] = (%d) \"%s\"\n", 
		            i, CardCopia->cmp[i][0], CardCopia->cmp[i]);
		}
    imposta_listacampi (Modifica, "listacampi");

		
    stampa_card (CardCopia, Modifica, "card_preview");
    set_vscroll_window (Modifica, "scrolledwindow7", 0);

#ifdef HIDE
    gtk_widget_hide (Base);
#endif
    gtk_widget_set_sensitive (Base, FALSE);
    MOSTRA_ON_MOUSE (Modifica);
  }
  else
    show_error_msg
      ("ERRORE: nessuna rubrica e` caricata. Apri un file di rubrica.");
}


void
on_button_modifica_clicked (GtkButton * button, gpointer user_data)
{
  on_modifica_activate (NULL, user_data);
}


gboolean
on_modificatext_key_press_event (GtkWidget * widget,
				 GdkEventKey * event, gpointer user_data)
{
  int key;
  GtkList *glst;

  key = get_whats_key (event);
  g_print ("\nKey 0x%x pressed on Modifica Box", key);
  switch (key)
    {
    case KEYB_INVIO:
      if (Status[S_CONFMOD])
	{
	  on_ok_modifica_clicked (NULL, user_data);
	  g_print (": Modifica apportata");
	}
      if (Status[S_SELCAMPO] + 1 < Status[S_CAMPI])
	{
	  glst = GTK_LIST (lookup_widget (Modifica, "listacampi"));

	  /* questa chiamata emette un segnale che aggiorna
	     Status[S_SELCAMPO]++ in modo automatico */
	  gtk_list_select_item (glst, Status[S_SELCAMPO]);
	  g_print ("\nSet listacampi item n.%d", Status[S_SELCAMPO]);

	  set_scrolled_window (Modifica, "scrolledwindow5", "listacampi",
			       ON_PAGE);
	}
      break;

    case KEYB_I:
      if (Status[S_KEYSHIFT] == KEYB_CTRL)
	stampa_infos ();
      else
	Status[S_CONFMOD] = 1;
      break;

    case KEYB_CTRL:
      Status[S_KEYSHIFT] = KEYB_CTRL;
      break;

    default:
      Status[S_CONFMOD] = 1;
      break;
    }

  return FALSE;
}


void
on_ok_modifica_clicked (GtkButton * button, gpointer user_data)
{
	RAF_DEBUG_INIT{"on_ok_modifica_clicked"};
  GtkWidget *entry;
  gchar *strn;

  Status[S_CONFMOD] = 0;
  if (Status[S_SELCAMPO] == -1)
  {
    show_error_msg ("ERRORE: nessun campo selezionato: seleziona un campo nella lista.");
    return;
  }

  entry = lookup_widget (GTK_WIDGET (Modifica), "modificatext");
	strn = M_STRDUP( gtk_entry_get_text (GTK_ENTRY (entry)) );
	if(!strn || !strn[0]) strn = strdup("_");
  strn = find_n_replace (strn, "\"", "''", FR_STRINGHE | FR_REPLACE);
  strn = find_n_replace (strn, "#", "=||=", FR_STRINGHE | FR_REPLACE);

	/* Queste non servono */
  //strn = find_n_replace(strn, "%", "'/,", FR_STRINGHE | FR_REPLACE);
  //strn = find_n_replace(strn, "\\\t", "\t", FR_STRINGHE | FR_REPLACE);
  //strn = find_n_replace(strn, "\\\n", "\n", FR_STRINGHE | FR_REPLACE);

  RAF_DEBUG ("Stringhe: %s <--> %s\n", (strn) ? strn : "(NULL)", CardCopia->cmp[Status[S_SELCAMPO]]);
  if (!strcmp ((char *) strn, CardCopia->cmp[Status[S_SELCAMPO]]))
    return;
  else
  {
    if (Status[S_SELCAMPO] == COG || Status[S_SELCAMPO] == NOM)
			Status[S_CMPMOD] = 1 + Status[S_SELCAMPO];
    else if (!Status[S_CMPMOD])
			Status[S_CMPMOD] = 1;
  }

  M_FREE (CardCopia->cmp[Status[S_SELCAMPO]]);
  CardCopia->cmp[Status[S_SELCAMPO]] = (char *) strn;
	if (Status[S_SELCAMPO] == COG || Status[S_SELCAMPO] == NOM) {
		CardCopia->cog = CardCopia->cmp[COG];
		CardCopia->nom = CardCopia->cmp[NOM];	
	}

  RAF_DEBUG ("modificatext: %s\n", CardCopia->cmp[Status[S_SELCAMPO]]);
  stampa_card (CardCopia, Modifica, "card_preview");
  set_vscroll_window (Modifica, "scrolledwindow7", 0);
}


void
on_listacampi_select_child (GtkList * list,
			    GtkWidget * widget, gpointer user_data)
{
  int ps;

  /* Ho preferito il piu` generico widget parametro passato
     dalla funzione invece che Modifica il puntatore globale */
  ps = seleziona_campo_in_lista (widget, "listacampi");

  /* Evito anche di chiamare la funzione quando e` palesemente inutile */
  if (ps >= 0)
    scrivi_modifica_campo (widget, "modificatext", Status[S_SELCAMPO]);
}


void
on_conferma_modifica_clicked (GtkButton * button, gpointer user_data)
{
  //int i;
	long n;
  struct card *rc;

  /* La conferma deve attuare la modifica effettuata */

  if (Status[S_CONFMOD])
  {
    on_ok_modifica_clicked (NULL, user_data);
    g_print ("\nModifica confermata (on_conferma_modifica_clicked) %d", 
		         raf_object_get_ind);
  }

  /* Ora questa nuova card la devo linkare alle altre
     sempre che sia stata cambiata */
  if (Status[S_CMPMOD])
		raf_obj_manage(RAF_OBJ_RPL, CardCopia);
	rc = raf_object_get_slt(RAF_OBJ_SLT);
	n  = raf_object_get_ind;
  g_print("\nContenuto(%ld): %s, %s", n, rc->cog, rc->nom);

  gtk_widget_hide (Modifica);
  gtk_widget_set_sensitive (Base, TRUE);
#ifdef HIDE
  gtk_widget_show (Base);
#endif


  if (Status[S_CMPMOD] > 1)
  {
    Status[S_MODIFICA] = 1;
    g_print ("\nStatus SELISTA: %ld", n);
    /* Quando si cambia il nome o cognome ad una persona
       e` possibile che al ritorno nella lista non sia piu`
       selezionato questo serve per stampare la card giusta */
    imposta_lista ();
    set_sensitive_tools (IF_NEED);
  }
  else if (Status[S_CMPMOD])
  {
    Status[S_MODIFICA] = 1;
    set_lista_item (n, !S_INIBIT);
    set_sensitive_tools (IF_NEED);
  }
}


void
on_annulla_modifica_clicked (GtkButton * button, gpointer user_data)
{
  gtk_widget_hide (Modifica);

  /* Prima vi era il codice della funzione chiamata
     ma l'ho sostituito con la chiamata alla funzione */
  /* on_modifica_destroy (NULL, user_data); */

  ANNULLA_MODIFICHE_CAMPI ();
  gtk_widget_set_sensitive (Base, TRUE);
#ifdef HIDE
  gtk_widget_show (Base);
#endif
}


void
on_modifica_destroy (GtkObject * object, gpointer user_data)
{
  Modifica = NULL;

  if (Status[S_AVVRTM] != AVT_DESTROYB)
    {
      /* E` prioritario salvare le modifiche della
         finestra base altrimenti si possono salvare
         anche le modifiche della finestra di editing */

      if (Status[S_CMPMOD])
	chiudi_con_modifiche (Modifica, AVT_DESTROYM);
      else
	{
	  ANNULLA_MODIFICHE_CAMPI ();
	  gtk_widget_set_sensitive (Base, TRUE);
#ifdef HIDE
	  gtk_widget_show (Base);
#endif
	}
    }
}


gboolean
on_modificatext_key_release_event (GtkWidget * widget,
				   GdkEventKey * event, gpointer user_data)
{
  int key;

  key = get_whats_key (event);
  if (key == KEYB_CTRL)
    Status[S_KEYSHIFT] = 0;

  return FALSE;
}

void
on_modificatext_clipboard (GtkEditable * editable, gpointer user_data)
{
  Status[S_CONFMOD] = 1;
  g_print ("\nClipboard on Modifica Box");
}

void
on_modificatext_text (GtkEditable * editable,
		      gchar * new_text,
		      gint new_text_length,
		      gint * position, gpointer user_data)
{
  if (Status[S_INIBIT] != S_LISTA)
  {
    Status[S_CONFMOD] = 1;
    g_print ("\nModifica Box text changed");
  }
}
