
#ifndef SUB_CALLING
# include <stdio.h>
# include "callbacks.h"
# include "pfunc.h"
# include "mfunc.h"
# include "sfunc.h"
#endif

#include <stdlib.h>
#include <string.h> 
#include "support.h"

#ifdef ANJUTA_MAKEFILE
# include "rafobj.h"
#endif

/* Questa puo` essere fusa con la set_lista_item
   in una funzione molto piu` generale */
void set_listacampi_item(int k)
{
 GtkList * glst;
 GtkWidget * list;

 if ( k > 0 )
 {
  g_print("\nSet listacampi item n.%d", k);
  list = lookup_widget (Creazione, "listacreacampi");
  glst = GTK_LIST( list );	
  gtk_list_select_item( glst, k-1);				

  Status[S_SELCAMPO] = k;
  set_scrolled_window(Creazione, "scrolledwindow9", "listacreacampi", ON_PAGE);
 }
}

int seleziona_campo_in_lista(GtkWidget * widget, const char * widget_name)
{
 int cd = -1;
 GtkWidget   * lst;
 GList       * dlist;
 GtkObject   * list_item;
 gchar       * item_data_string;

 g_print("\nSeleziona campo in lista started (%d)", Status[S_CONFMOD]);

 lst = lookup_widget (GTK_WIDGET (widget), widget_name);
 dlist = GTK_LIST(lst)->selection;
 item_data_string = NULL;
 while (dlist)
 {
  list_item = GTK_OBJECT(dlist->data);
  item_data_string = gtk_object_get_data(list_item, list_item_data_key);
  cd = atoi(item_data_string);

  dlist=dlist->next;
 }

 /* Questo condizione serve per evitare la     
  * ripetizione del codice dopo l'impostalista 
  * che non cambia la selezione ma lancia un segnale 
  */
 if(cd != Status[S_SELCAMPO] && cd >= 0)	
 {
  if(Status[S_CONFMOD])				
  {
   Status[S_CONFMOD] = 0;
   g_print("\nModifica clicked call");
   on_ok_modifica_clicked (NULL, NULL);
   g_print("\nModifica confermata (%s)", widget_name);
  }
  Status[S_SELCAMPO] = cd;			
  g_print("\nLista campi changed (%d)", Status[S_SELCAMPO]);
 }
 else if(cd < 0)
  g_print("\nERROR: selected invalid list child");
 else
 {
  g_print("\nSaltato un segnale inutile");
  cd = -1;
 }

 return cd;
}


void imposta_listacampi(GtkWidget *widget, const char * widget_name)
{
 int i;
 static int previous = 0;
 GtkWidget * list, * list_item;
 GList     * dlist;

 
 g_print("\nImposta lista campi started");

 /* Scrittura degli elementi della lista:
  * il codice non e` un campo modificabile ed obbligatorio, 
  * quindi viene inizializzato in modo unico alla creazione 
  * di una nuova card
  */
 dlist = NULL;
 for (i = 1; i < Status[S_CAMPI]; i++)	  				
 {									
  if(Campi[i] != NULL)
  {
   list_item = gtk_list_item_new_with_label(M_STRDUP(Campi[i]));
   dlist = g_list_prepend(dlist, list_item);
   gtk_widget_show(list_item);
   gtk_object_set_data(GTK_OBJECT(list_item), list_item_data_key, IndexCampi[i]);
  }
 }
 
 /* Secondo Paolo Bongiorno <p.bongy@tin.it> nel creare una lista (dlist) il motore 
  * delle librerie glib non conserva il puntatore alla coda della lista e quindi 
  * mettere in _append un elemento richiede un tempo proporzionale alla  lunghezza 
  * della lista. Per questo motivo sugggerisce di usare g_list_prepend magari in 
  * combinazione con g_list_reverse.
  */
 dlist = g_list_reverse(dlist);

  
 /* 
  * Pulizia del contenuto della precedente lista 
  */
 list = lookup_widget (GTK_WIDGET (widget), widget_name);		
 if(previous > 0)
  gtk_list_clear_items (GTK_LIST(list), 0, previous);           	
 previous = Status[S_CAMPI];


 /* Questa codice farebbe partire la selezione del primo campo della lista
  * ma lo status di inibizione lo impedisce ma nonostante questo occorre 
  * riallineare lo stato con un set item (solo in creazione).
  */
 Status[S_CONFMOD] = 0;
 //Status[S_SELCAMPO] = 1;
 Status[S_INIBIT] = S_LISTA;
 gtk_list_prepend_items(GTK_LIST(list), dlist);
 Status[S_INIBIT] = -1;

 /* Nel caso della finestra di modifica questo non serve */
 if(widget == Creazione)
  set_listacampi_item( (Status[S_SELCAMPO] < 0) ? 1 : Status[S_SELCAMPO]);
 //else
 //set_lista_item(Status[S_SELCAMPO], S_INIBIT);

 /* Questo invece serve per avere lo scroll giusto al ritorno 
  * ma ovviamente funziona solo fino a quando le modifiche non 
  * decretano un nuovo ordinamento dei nominativi 
  */
 //set_lista_item((Status[S_SELISTA] < 0) ? 0 : Status[S_SELISTA], !S_INIBIT); 

 g_print("\nImposta lista campi on %s returned", widget_name);
}


void scrivi_modifica_campo(GtkWidget * widget, const char * widget_name, int cmp)
{
 char * txt; 

 g_print("\nScrivi su %s (%d, %d), ", widget_name, Status[S_CONFMOD], cmp);
 if(cmp > 0 && cmp < Status[S_CAMPI])
 {
  txt = M_STRDUP(CardCopia->cmp[cmp]);
  g_print("ContenutoCampi: \"%s\"", txt);
  if( !strcmp(txt, "_") )
   txt[0] = 0;
  else
   txt = find_n_replace(txt, "\n", "\\n", FR_REPLACE | FR_STRINGHE);

  /* Questo codice una volta era la funzione
   * void set_modifica(const char * strn)
   * per aiuto ho mantenuto lo scope di *entry 
   */
  {
   GtkWidget * entry;

   entry = lookup_widget (GTK_WIDGET (widget), widget_name);

   /* txt viene allocato dinamicamente e non viene rilasciato
    * con un del_text quindi si verifica un memory leak 
    */
   gtk_entry_set_text(GTK_ENTRY (entry), txt);
  }
 }
}


struct card *duplica_card(struct card *crd)
{
	int i;
	struct card *rc;

	rc = (struct card *) malloc (sizeof (struct card));
	for(i = 0; i < MAX_N_CAMPI; i++) 
		rc->cmp[i] = M_STRDUP(crd->cmp[i]);
	rc->cog = rc->cmp[COG];
	rc->nom = rc->cmp[NOM];

	return rc;
}

#ifdef GET_NEW_CODE
int get_new_code(int * code, int * last_lst)
{
 int max, i, prv, c, ret = 0;

 c = 0;
 prv = -1;
 /* max = Lista[0]->num; */
 max = -1;
 for(i = 0; i < Status[S_CARDS]; i++)
 {
  if(Lista[i]->num > max)
   max = Lista[i]->num;

  if(Lista[i]->nxt == NULL)
  {
   c++;
   prv = i;
  }
 }
 if(max == 0)
 {
  g_print("\nERROR: new code searcing not correct value %d", max+1);
  ret = -2;
 }
 max++;

 if(c > 1 || prv < 0)
 {
  g_print("\nERROR: new code searcing not correct value %d (%d,%d)", max, c, prv);
  ret = -1;
 }

 *code = max;
 *last_lst = prv;
 return ret;
}

long create_n_link_new_card(void)
{
 int i, len;
 char * buf;
 struct card * crd;
 long new_cod;

 len = 16 + Status[S_CAMPI]*5;
 buf = (char *)malloc( len );
 crd = (struct card *)malloc( sizeof(struct card) );

 g_print(" len = %d", len);

 new_cod = raf_object_get_num;
 sprintf(buf,"\"#%05ld\"\t", new_cod);

 /* Il numero di campi sucessivi al codice sono
  * totali Status[S_CAMPI] meno uno e devo chiudere 
  * con un carattere# 
  */  
 for(i = 0; i < Status[S_CAMPI]-1; i++)
  sprintf(buf, "%s\"_\"\t", buf);
 sprintf(buf, "%s\"#\"", buf);

 /* Questo adatta la nuova card a quelle in memoria */
 buf[5]  = 0;
 buf[9]  = 0;
 buf[13] = 0;
 for(i = 0; i < len; i ++)	
  if( buf[i] == '\t')
   buf[i] = 0;

 /* Inizializza la nuova card */
 crd->cod = &buf[1];
 crd->cog = &buf[8];
 crd->nom = &buf[12];
 crd->num = new_cod;
 
 raf_obj_manage(RAF_OBJ_ADD, crd);  
 M_FREE(crd);

 return new_cod;
}
#endif



void ispezione(const char * pointer)
{
 static char first = 1;
 static int last[100];
 int i, w;
 
 g_print("\n");
 for (i = 0; i < 100; i++)
 {
  w = (int)(pointer[i] & 0xff);
  if(first)
  {
   g_print(" %2d:%3d ", i, w); 
   first = 0;
  }
  else
   g_print("%c%2d:%3d ", (last[i] == w) ? ' ' : '*', i, w); 

  last[i]  = w;
 }
 g_print("\n");
}

